package jfd.ale;

import java.util.Hashtable;
import java.text.MessageFormat;

abstract class MethodVisitor extends Visitor
{
   protected Hashtable table       = null;
   protected String section        = null;
   protected String name           = null;
   protected String attribute      = null;

   public MethodVisitor(
      Hashtable table, String section, String name, String attribute
   )
   {
      this.section   = section;
      this.table     = table;
      this.name      = name;
      this.attribute = attribute;
   }

   protected abstract String getFormat();

   protected abstract boolean isValid(String target, String methodName);

   public void visited(MethodNode methodNode)
   {
      String target     = methodNode.getTarget();
      String methodName = methodNode.getName();

      if(!isValid(target, methodName))
      {
         System.out.println(
            MessageFormat.format(
               getFormat(),
               new Object[] { section, attribute, name, target, methodName }
            )
         );

         System.exit(-1);
      }
   }
}
